;  GRID.LSP draws celing grid
;by John Roberts, Thomas & Olive;Enter grid type
(defun C:GRDSPACE ()
       (setq HS (getint "\nEnter horizontal spacing 24 or 48: "))
       (setq VS (getint "\nEnter vertical spacing 24 or 48: "))
)
(defun C:GRDCENT ()
       (prompt "\nEnter horiz. space center 0, or line center 1:<")
       (prin1 xcc)(prompt "> ")
       (setq temp (getint ))
       (setq xcc (if (null temp) xcc temp))
       (setq xc (abs (- xcc 1)));change xc from 0 to 1 or 1 to 0
       (prompt "\nEnter vert. space center 0, or line center 1:<")
       (prin1 ycc)(prompt "> ")
       (setq temp (getint ))
       (setq ycc (if (null temp) ycc temp))
       (setq yc (abs (- ycc 1)));change yc from 0 to 1 or 1 to 0
       (prompt "\nEnter minimum tile width: <")
       (prin1 minw)(prompt "> ")
       (setq temp (getint ))
       (setq minw (if (null temp) minw temp))
       (prompt "\nEnter maximum tile width: <")
       (prin1 maxw)(prompt "> ")
       (setq temp (getint ))
       (setq maxw (if (null temp) maxw temp))
)
(defun C:RMGRD ()
       (command "OSNAP" "NEAR")
       (setq LW (Getpoint "\nPick left wall: "))
       (setq RW (Getpoint "\nPick right wall: "))
       (setq TW (Getpoint "\nPick top wall: "))
       (setq BW (Getpoint "\nPick bottom wall: "))
       (command "OSNAP" "NONE")
;finds room center point
       (setq X3 (/(+(Car LW)(Car RW)) 2))
       (setq Y3 (/(+(Cadr TW)(Cadr BW)) 2))
;Set up variables
       (setq X1 (car LW))
       (setq X2 (car RW))
       (setq Y1 (cadr BW))
       (setq Y2 ( cadr TW))
       (setq AA (* YC 0.5))
       (setq BB (* XC 0.5))
       (setq HX (/ HS 2))
       (setq HY (/ VS 2))
       (setq HXD (/(- X2 X1) 2))
       (setq HYD (/(- Y2 Y1) 2))
;find horizontal line start point
       (setq A (+ (/ HYD VS) AA))
       (setq A1 (fix A))
       (setq A2 (- A1 AA))
       (setq Y4 (+ (* A2 VS) Y3))
       (setq e1 (- y2 y4))
       (setq e2 (if (< e1 minw)(+ e1 hy) e1))
       (setq e2 (if (> e1 maxw)(- e1 hy) e2))
       (setq y4 (- y2 e2))
       (setq P1 (list X1 Y4))
       (setq P2 (list X2 Y4))
;loop for drawing horizontal lines
       (while (< (- Y2 Y4) (- Y2 Y1))
       (command  "line" P1 P2 "")
       (setq Y4 (- Y4 VS))
       (setq P1
       (list X1 Y4))
       (setq P2 (list X2 Y4))
       )
;find vertical line start point
       (setq B (+ (/ HXD HS) BB))
       (setq B1 (fix B))
       (setq B2 (- B1 BB))
       (setq X4 (+ (* B2 HS) X3))
       (setq f1 (- x2 x4))
       (setq f2 (if (< f1 minw)(+ f1 hx) f1))
       (setq f2 (if (> f1 maxw)(- f1 hx) f2))
       (setq x4 (- x2 f2))
       (setq P3 (list X4 Y2))
       (setq P4 (list X4 Y1))
;Loop for drawing vertical lines
       (while (< (- X2 X4) (- X2 X1))
       (command "line" P3 P4 "")
       (setq X4 (- X4 HS))
       (setq P3 (list X4 Y2))
       (setq P4 (list X4 Y1))
       )
)